Go to the latest version of this document.

# ``twisted`.`trial`.`unittest``

module documentation
(source)

Things likely to be used by writers of unit tests.

Class | `PyUnitResultAdapter` | Wrap a `TestResult` from the standard library's `unittest` so that it supports the extended result types from Trial, and also supports `twisted.python.failure.Failure`s being passed to `addError` and `addFailure`...
Class | `SynchronousTestCase` | A unit test. The atom of the unit testing universe.
Class | `TestCase` | A unit test. The atom of the unit testing universe.
Class | `TestDecorator` | Decorator for test cases.
Class | `TestSuite` | Extend the standard library's `TestSuite` with a consistently overrideable `run` method.
Class | `Todo` | Internal object used to mark a `TestCase` as 'todo'. Tests marked 'todo' are reported differently in Trial `TestResult`s. If todo'd tests fail, they do not fail the suite and the errors are reported in a separate category...
Exception | `FailTest` | Raised to indicate the current test has failed to pass.
Function | `decorate` | Decorate all test cases in `test` with `decorator`.
Function | `makeTodo` | Return a `Todo` object built from `value`.

def decorate(test, decorator): (source)

Decorate all test cases in `test` with `decorator`.

`test` can be a test case or a test suite. If it is a test suite, then the structure of the suite is preserved.

`decorate` tries to preserve the class of the test suites it finds, but assumes the presence of the `_tests` attribute on the suite.

Parameters
test | The `TestCase` or `TestSuite` to decorate.
decorator | A unary callable used to decorate `TestCase`s.

Returns
A decorated `TestCase` or a `TestSuite` containing decorated `TestCase`s.

def makeTodo(value: `str | tuple[type[BaseException] | Iterable[type[BaseException]], str]`) -> `Todo`: (source)

Return a `Todo` object built from `value`.

If `value` is a string, return a Todo that expects any exception with `value` as a reason. If `value` is a tuple, the second element is used as the reason and the first element as the excepted error(s).

Parameters
value:`str | tuple[type[BaseException] | Iterable[type[BaseException]], str]` | A string or a tuple of `(errors, reason)`, where `errors` is either a single exception class or an iterable of exception classes.

Returns
`Todo` | A `Todo` object.